<template>
  <section
    v-click-outside="onEditEnd"
    class="flex flex-wrap gap-2 sm:gap-4 p-4"
    :class="{ 'cursor-pointer': !isEditable }"
    @click="onEditStart"
  >
    <v-tooltip
      v-if="!isEditable"
      activator="parent"
      location="right"
      open-on-click
    >
      Нажмите, чтобы изменить
    </v-tooltip>

    <section v-if="!isEditable">
      <v-icon icon="mdi-text-short" />
    </section>

    <section
      v-if="!isEditable"
      class="flex-auto"
    >
      <ProfitDisplay
        :value="correction.value"
        mode="display"
      />

      <p class="pt-2 text-lg text-wrap text-gray-500">
        {{ correction.reason }}
      </p>
    </section>

    <section
      v-if="isEditable"
      class="flex-auto shrink-0"
    >
      <NumberInput
        v-model="correction.value"
        :error="nonZeroValueError"
        density="compact"
        mode="price"
        :min="-1 * INT_SIZE"
        :max="INT_SIZE"
        :step="100"
        non-zero
        autofocus
      />

      <v-text-field
        v-model="correction.reason"
        class="mt-2"
        :rules="[validateReason]"
        :maxlength="MAX_BOOKING_CORRECTION_REASON_LENGTH"
        placeholder="Обоснование"
        density="compact"
        clearable
      />
    </section>

    <section
      v-if="isEditable"
      class="pt-1 hidden sm:block"
    >
      <v-btn
        icon="mdi-close"
        variant="plain"
        color="error"
        @click="onDeleteClick"
      />
    </section>

    <section
      v-if="isEditable"
      class="w-full flex justify-end sm:hidden"
    >
      <v-btn
        prepend-icon="mdi-close"
        text="Удалить"
        variant="plain"
        color="error"
        @click="onDeleteClick"
      />
    </section>
  </section>
</template>

<script setup lang="ts">
import { computed, reactive, ref } from 'vue';

import {
  MIN_BOOKING_CORRECTION_REASON_LENGTH,
  MAX_BOOKING_CORRECTION_REASON_LENGTH, INT_SIZE,
} from '@/declarations';

import { createStringValidator } from '@/validators';

import NumberInput from '@/components/content/NumberInput.vue';
import ProfitDisplay from '@/components/content/ProfitDisplay.vue';

type CorrectionData = (
  Omit<IProfitCorrection, 'id'> &
  { value: number; }
);

const props = defineProps<{ data: IProfitCorrection }>();
const emit = defineEmits(['update', 'delete']);

const FALLBACK_REASON_TEXT = 'Причина не указана';
const isEditable = ref(props.data.value === 0);

const validateReason = createStringValidator({
  required: true,
  length: {
    min: MIN_BOOKING_CORRECTION_REASON_LENGTH,
    max: MAX_BOOKING_CORRECTION_REASON_LENGTH,
  },
});

const correction = reactive<CorrectionData>({
  value: Number(props.data.value),
  reason: props.data.reason,
});

const nonZeroValueError = computed(() => {
  return Number(correction.value) === 0
    ? 'Это обязательное поле'
    : '';
});

const onEditStart = () => {
  isEditable.value = true;
};

const onEditEnd = () => {
  if (!isEditable.value) return;

  if (correction.value === 0) {
    return emit('delete', props.data.id);
  }

  if (validateReason(correction.reason) !== true) {
    correction.reason = FALLBACK_REASON_TEXT;
  }

  isEditable.value = false;

  emit('update', {
    id: props.data.id,
    value: correction.value,
    reason: correction.reason,
  });
};

const onDeleteClick = () => {
  emit('delete', props.data.id);
};
</script>